---
product: "AG Grid"
title: "Provided Overlays"
description: "The grid shows built-in overlays when data is loading or being exported and when there is no data or no rows match the current filter."
framework: javascript
version: "36.2.0"
related:
    - title: "Overview"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/overlays-overview/"
    - title: "Active Overlay"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/overlays-active/"
    - title: "Loading Rows"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/loading-rows/"
llms: "https://www.ag-grid.com/archive/36.2.0/llms.txt"
---

# Provided Overlays

The grid shows built-in overlays when data is loading or being exported and when there is no data or no rows match the current filter.

The following example demonstrates most of the provided overlays.

- Toggle the loading state to show/hide the loading overlay.
- Note that the loading overlay takes precedence over the other provided overlays if they are shown at the same time.
- Clear Row Data shows the no rows overlay.
- Set Non Matching Filter sets row data and a non-matching filter to show the no matching rows overlay.
- Export CSV exports the data to CSV and shows the exporting overlay.

#### Provided Overlays

```ts
import {
  ClientSideRowModelModule,
  CsvExportModule,
  GridApi,
  GridOptions,
  ModuleRegistry,
  TextFilterModule,
  createGrid,
  enableDevValidations,
} from "ag-grid-community";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ClientSideRowModelModule,
  TextFilterModule,
  CsvExportModule,
]);

interface IAthlete {
  athlete: string;
  country: string;
}

let gridApi: GridApi<IAthlete>;

const gridOptions: GridOptions<IAthlete> = {
  loading: true,
  defaultColDef: {
    filter: true,
  },
  columnDefs: [{ field: "athlete" }, { field: "country" }],
};

function setLoading(value: boolean) {
  gridApi!.setGridOption("loading", value);
}

function onBtnClearRowData() {
  gridApi!.setGridOption("rowData", []);
}

function onBtnSetRowData() {
  gridApi!.setGridOption("rowData", [
    { athlete: "Michael Phelps", country: "US" },
    { athlete: "Chris Hoy", country: "UK" },
  ]);
}

function onBtnSetFilter() {
  gridApi!.setGridOption("rowData", [
    { athlete: "Michael Phelps", country: "US" },
    { athlete: "Chris Hoy", country: "UK" },
  ]);
  gridApi!.setFilterModel({
    country: { filterType: "text", type: "equals", filter: "Spain" },
  });
}

function onBtnClearFilter() {
  gridApi!.setFilterModel(null);
}

function onCsvExport() {
  gridApi!.exportDataAsCsv();
}

const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);

if (typeof window !== "undefined") {
  // Attach external event handlers to window so they can be called from index.html
  (<any>window).setLoading = setLoading;
  (<any>window).onBtnClearRowData = onBtnClearRowData;
  (<any>window).onBtnSetRowData = onBtnSetRowData;
  (<any>window).onBtnSetFilter = onBtnSetFilter;
  (<any>window).onBtnClearFilter = onBtnClearFilter;
  (<any>window).onCsvExport = onCsvExport;
}
```

[Live example: Provided Overlays](https://www.ag-grid.com/archive/36.2.0/examples/overlays-provided/provided-overlays/typescript/)

## Loading

The loading overlay is displayed when the grid property `loading` is set to `true`, and takes precedence over the other provided overlays.

With the Client-Side Row Model, enable `loadingRows` to display [Loading Rows](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/loading-rows/) instead of the overlay while `loading=true`.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `loading` | `boolean` |  |  |  |

## No Rows

When there are no rows the grid automatically displays the no-rows overlay.

## No Matching Rows

The no-matching-rows overlay is displayed when the grid has rows but none of the rows match the current filter criteria.

## Exporting

The exporting overlay is displayed when data is being exported from the grid to CSV or Excel.

## File Input

When `processFileInput` is provided and `rowData` is not set, the grid shows a built-in file input overlay. Users can drag a file onto the overlay or click the browse button to select one. The `processFileInput` callback receives a `params` object containing the selected `files` along with `success` and `fail` callbacks, enabling the application to parse the files and load or reject the data.

The file input overlay pairs well with [Auto-Generate Columns](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/auto-generate-columns/#file-drop-overlay) to load data without defining columns upfront. See that page for the `processFileInput` callback and a worked example.

## Customisation

The provided overlays can be customised to change their content or completely replaced with custom components. The grid still manages the timing of when the overlays are displayed based on grid state.

### Text Customisation

Customise the text within the provided overlays via the `overlayComponentParams` grid option using the `OverlayComponentUserParams` interface.

Properties available on the `OverlayComponentUserParams` interface.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `loading` | `LoadingOverlayUserParams` |  |  |  |
| `noRows` | `NoRowsOverlayUserParams` |  |  |  |
| `noMatchingRows` | `NoMatchingRowsOverlayUserParams` |  |  |  |
| `exporting` | `ExportingOverlayUserParams` |  |  |  |
| `fileInput` | `FileInputOverlayUserParams` |  |  |  |

```js
const gridOptions = {
    overlayComponentParams: {
        loading: { overlayText: 'Please wait while your data is loading...' },
        noRows: { overlayText: 'This grid has no data!' },
        noMatchingRows: { overlayText: 'Current Filter Matches No Rows' },
        exporting: { overlayText: 'Exporting your data...' },
        fileInput: { overlayText: 'Provide a file...' },
    },

    // other grid options ...
}
```

#### Provided Overlays Custom Text

```ts
import {
  ClientSideRowModelModule,
  CsvExportModule,
  GridApi,
  GridOptions,
  ModuleRegistry,
  OverlayComponentUserParams,
  TextFilterModule,
  createGrid,
  enableDevValidations,
} from "ag-grid-community";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ClientSideRowModelModule,
  CsvExportModule,
  TextFilterModule,
]);

interface IAthlete {
  athlete: string;
  country: string;
}

let gridApi: GridApi<IAthlete>;

const overlayComponentParams: OverlayComponentUserParams = {
  loading: { overlayText: "Please wait while your data is loading..." },
  noRows: { overlayText: "This grid has no data!" },
  noMatchingRows: { overlayText: "Current Filter Matches No Rows" },
  exporting: { overlayText: "Exporting your data..." },
};

const gridOptions: GridOptions<IAthlete> = {
  loading: true,
  defaultColDef: {
    filter: true,
  },
  columnDefs: [{ field: "athlete" }, { field: "country" }],
  overlayComponentParams,
};

function setLoading(value: boolean) {
  gridApi!.setGridOption("loading", value);
}

function onBtnClearRowData() {
  gridApi!.setGridOption("rowData", []);
}

function onBtnSetRowData() {
  gridApi!.setGridOption("rowData", [
    { athlete: "Michael Phelps", country: "US" },
    { athlete: "Chris Hoy", country: "UK" },
  ]);
}

function onBtnSetFilter() {
  gridApi!.setGridOption("rowData", [
    { athlete: "Michael Phelps", country: "US" },
    { athlete: "Chris Hoy", country: "UK" },
  ]);
  gridApi!.setFilterModel({
    country: { filterType: "text", type: "equals", filter: "Spain" },
  });
}

function onBtnClearFilter() {
  gridApi!.setFilterModel(null);
}

function onCsvExport() {
  gridApi!.exportDataAsCsv();
}

const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);

if (typeof window !== "undefined") {
  // Attach external event handlers to window so they can be called from index.html
  (<any>window).setLoading = setLoading;
  (<any>window).onBtnClearRowData = onBtnClearRowData;
  (<any>window).onBtnSetRowData = onBtnSetRowData;
  (<any>window).onBtnSetFilter = onBtnSetFilter;
  (<any>window).onBtnClearFilter = onBtnClearFilter;
  (<any>window).onCsvExport = onCsvExport;
}
```

[Live example: Provided Overlays Custom Text](https://www.ag-grid.com/archive/36.2.0/examples/overlays-provided/provided-overlays-text/typescript/)

### Custom Overlay Components

To provide a custom component for the provided overlays implement one of the following interfaces: `ILoadingOverlayComp`, `INoRowsOverlayComp`, `INoMatchingRowsOverlayComp` or `IExportingOverlayComp`.

Implement this interface to provide a custom overlay when data is being loaded.

```ts

interface ILoadingOverlayComp&lt;TData = any, TContext = any&gt; {
  // Return the DOM element of your component, this is what the grid puts into the DOM 
  getGui(): <a tabindex="0" href="https://developer.mozilla.org/en-US/docs/Web/API/HTMLElement" target="_blank" rel="noreferrer">HTMLElement</a>;

  // Gets called once by grid when the component is being removed; if your component needs to do any cleanup, do it here 
  destroy?(): void;

  // The init(params) method is called on the component once. 
  init?(params: TParams): AgPromise<<span/>void>  |  void;

  // Gets called when the `overlayComponentParams` grid option is updated
  refresh?(params: TParams): void;

}
```

The `INoRowsOverlayComp`, `INoMatchingRowsOverlayComp` or `IExportingOverlayComp` interfaces follow a similar pattern to the `ILoadingOverlayComp` above.

Then set the custom overlay to its matching key in the `components` map as described in [Overriding Grid Components](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/components/#overriding-grid-components). Custom parameters can be supplied via the `overlayComponentParams` grid option.

```js
const gridOptions = {
    components: {
        agLoadingOverlay: CustomLoadingOverlay,
        agNoRowsOverlay: CustomNoRowsOverlay,
        agNoMatchingRowsOverlay: CustomNoMatchingRows,
        agExportingOverlay: CustomExportingOverlay
    },

    // other grid options ...
}
```

### Overlay Component Selector

To dynamically override a provided overlay with a custom component implement the `overlayComponentSelector(params)` callback. The callback params include an `overlayType` property which identifies which of the provided overlays that grid wants to display. The return type should match the `OverlaySelectorResult` interface.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `overlayComponentSelector` | `OverlaySelectorFunc` |  |  |  |

Returning `undefined` from the selector will fall back to the overlay specified in `params.overlayType`.

```js
const gridOptions = {
    overlayComponentSelector: (params) => {
        if (params.overlayType === 'loading') {
            return {
                component: CustomLoadingOverlay,
                params: {
                    loadingMessage: 'Please wait while data is loading...'
                }
            };
        }
        // return undefined to use the provided overlay for other overlay types
        return undefined;
    },

    // other grid options ...
}
```

In the example below the loading overlay is overridden via the `overlayComponentSelector` but the no rows overlay is not.

#### Overlay Component Selector

```ts
import {
  ClientSideRowModelModule,
  ColDef,
  GridApi,
  GridOptions,
  IOverlayParams,
  ModuleRegistry,
  createGrid,
  enableDevValidations,
} from "ag-grid-community";
import { CustomLoadingOverlay } from "./customLoadingOverlay";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([ClientSideRowModelModule]);

interface IAthlete {
  athlete: string;
  country: string;
}

const columnDefs: ColDef[] = [{ field: "athlete" }, { field: "country" }];

const rowData: IAthlete[] = [];

let gridApi: GridApi<IAthlete>;

const gridOptions: GridOptions<IAthlete> = {
  defaultColDef: {
    flex: 1,
  },

  loading: true,

  columnDefs: columnDefs,
  rowData,

  overlayComponentSelector: (params: IOverlayParams) => {
    if (params.overlayType === "loading") {
      return {
        component: CustomLoadingOverlay,
        params: {
          loadingMessage: "Please wait while data is loading...",
        },
      };
    }
    // return undefined to use the provided overlay for other overlay types
    return undefined;
  },
};

function setLoading(value: boolean) {
  gridApi!.setGridOption("loading", value);
}

const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);

if (typeof window !== "undefined") {
  // Attach external event handlers to window so they can be called from index.html
  (<any>window).setLoading = setLoading;
}
```

[Live example: Overlay Component Selector](https://www.ag-grid.com/archive/36.2.0/examples/overlays-provided/custom-overlay-selector/typescript/)

### Combined Overlay Component

Provide a custom component to `overlayComponent` to be used in place of all the provided overlays. The custom component receives a `overlayType` parameter which identifies which of the provided overlays should be displayed. This can be used to conditionally render different content based on the overlay type.

Custom parameters can be supplied to the overlay component via the `overlayComponentParams` grid option.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `overlayComponent` | `any` |  |  |  |
| `overlayComponentParams` | `any` |  |  |  |

```js
const gridOptions = {
    overlayComponent: CustomOverlay,
    overlayComponentParams: {
        loadingMessage: 'Custom loading message',
        noRowsMessage: 'Custom no rows message'
    },

    // other grid options ...
}
```

In the example below a single custom component is provided to the grid which contains the conditional logic about what to render for each `overlayType`.

#### Overlay Component

```ts
import {
  ClientSideRowModelModule,
  ColDef,
  GridApi,
  GridOptions,
  ModuleRegistry,
  createGrid,
  enableDevValidations,
} from "ag-grid-community";
import { CustomOverlay } from "./customOverlay";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([ClientSideRowModelModule]);

interface IAthlete {
  athlete: string;
  country: string;
}

const columnDefs: ColDef[] = [{ field: "athlete" }, { field: "country" }];

let gridApi: GridApi<IAthlete>;

const gridOptions: GridOptions<IAthlete> = {
  defaultColDef: {
    flex: 1,
  },

  loading: true,

  columnDefs: columnDefs,
  rowData: [],

  overlayComponent: CustomOverlay,
  overlayComponentParams: {
    loadingMessage: "Custom loading message",
    noRowsMessage: "Custom no rows message",
  },
};

function setLoading(value: boolean) {
  gridApi!.setGridOption("loading", value);
}

const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);

if (typeof window !== "undefined") {
  // Attach external event handlers to window so they can be called from index.html
  (<any>window).setLoading = setLoading;
}
```

[Live example: Overlay Component](https://www.ag-grid.com/archive/36.2.0/examples/overlays-provided/custom-overlay-component/typescript/)

## Suppress Overlays

Each provided overlay can be suppressed via the `suppressOverlays` grid option which accepts an array of overlay types to suppress.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `suppressOverlays` | `OverlayType[]` |  |  |  |

## Legacy Customisation

Previously, the loading and no-rows overlays were customised via: `loadingOverlayComponent` and `noRowsOverlayComponent`. This approach is now superseded by the `overlayComponent` but the properties remain for backwards compatibility. The documentation for these properties is available [here](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/overlays/).


---
product: "AG Grid"
title: "Provided Overlays"
description: "The grid shows built-in overlays when data is loading or being exported and when there is no data or no rows match the current filter."
framework: angular
version: "36.2.0"
related:
    - title: "Overview"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/overlays-overview/"
    - title: "Active Overlay"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/overlays-active/"
    - title: "Loading Rows"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/loading-rows/"
llms: "https://www.ag-grid.com/archive/36.2.0/llms.txt"
---

# Provided Overlays

The grid shows built-in overlays when data is loading or being exported and when there is no data or no rows match the current filter.

The following example demonstrates most of the provided overlays.

- Toggle the loading state to show/hide the loading overlay.
- Note that the loading overlay takes precedence over the other provided overlays if they are shown at the same time.
- Clear Row Data shows the no rows overlay.
- Set Non Matching Filter sets row data and a non-matching filter to show the no matching rows overlay.
- Export CSV exports the data to CSV and shows the exporting overlay.

#### Provided Overlays

```ts
import { Component } from "@angular/core";
import { AgGridAngular } from "ag-grid-angular";
import "./styles.css";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  CsvExportModule,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  TextFilterModule,
  enableDevValidations,
} from "ag-grid-community";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ClientSideRowModelModule,
  TextFilterModule,
  CsvExportModule,
]);

interface IAthlete {
  athlete: string;
  country: string;
}

@Component({
  selector: "my-app",
  standalone: true,
  imports: [AgGridAngular],
  template: `<div class="example-wrapper">
    <div>
      <label class="checkbox">
        <input
          type="checkbox"
          checked=""
          (change)="setLoading($event.currentTarget.checked)"
        />
        loading
      </label>

      <button (click)="onBtnSetRowData()">Set Row Data</button>
      <button (click)="onBtnClearRowData()">Clear Row Data</button>
      <button (click)="onBtnSetFilter()">Set Non Matching Filter</button>
      <button (click)="onBtnClearFilter()">Clear Filter</button>
      <button (click)="onCsvExport()">Export CSV</button>
    </div>
    <ag-grid-angular
      style="width: 100%; height: 100%;"
      [loading]="true"
      [defaultColDef]="defaultColDef"
      [columnDefs]="columnDefs"
      [rowData]="rowData"
      (gridReady)="onGridReady($event)"
    />
  </div> `,
})
export class AppComponent {
  private gridApi!: GridApi<IAthlete>;

  defaultColDef: ColDef = {
    filter: true,
  };
  columnDefs: ColDef[] = [{ field: "athlete" }, { field: "country" }];
  rowData!: IAthlete[];

  setLoading(value: boolean) {
    this.gridApi.setGridOption("loading", value);
  }

  onBtnClearRowData() {
    this.gridApi.setGridOption("rowData", []);
  }

  onBtnSetRowData() {
    this.gridApi.setGridOption("rowData", [
      { athlete: "Michael Phelps", country: "US" },
      { athlete: "Chris Hoy", country: "UK" },
    ]);
  }

  onBtnSetFilter() {
    this.gridApi.setGridOption("rowData", [
      { athlete: "Michael Phelps", country: "US" },
      { athlete: "Chris Hoy", country: "UK" },
    ]);
    this.gridApi.setFilterModel({
      country: { filterType: "text", type: "equals", filter: "Spain" },
    });
  }

  onBtnClearFilter() {
    this.gridApi.setFilterModel(null);
  }

  onCsvExport() {
    this.gridApi.exportDataAsCsv();
  }

  onGridReady(params: GridReadyEvent<IAthlete>) {
    this.gridApi = params.api;
  }
}
```

[Live example: Provided Overlays](https://www.ag-grid.com/archive/36.2.0/examples/overlays-provided/provided-overlays/angular/)

## Loading

The loading overlay is displayed when the grid property `loading` is set to `true`, and takes precedence over the other provided overlays.

With the Client-Side Row Model, enable `loadingRows` to display [Loading Rows](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/loading-rows/) instead of the overlay while `loading=true`.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `loading` | `boolean` |  |  |  |

## No Rows

When there are no rows the grid automatically displays the no-rows overlay.

## No Matching Rows

The no-matching-rows overlay is displayed when the grid has rows but none of the rows match the current filter criteria.

## Exporting

The exporting overlay is displayed when data is being exported from the grid to CSV or Excel.

## File Input

When `processFileInput` is provided and `rowData` is not set, the grid shows a built-in file input overlay. Users can drag a file onto the overlay or click the browse button to select one. The `processFileInput` callback receives a `params` object containing the selected `files` along with `success` and `fail` callbacks, enabling the application to parse the files and load or reject the data.

The file input overlay pairs well with [Auto-Generate Columns](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/auto-generate-columns/#file-drop-overlay) to load data without defining columns upfront. See that page for the `processFileInput` callback and a worked example.

## Customisation

The provided overlays can be customised to change their content or completely replaced with custom components. The grid still manages the timing of when the overlays are displayed based on grid state.

### Text Customisation

Customise the text within the provided overlays via the `overlayComponentParams` grid option using the `OverlayComponentUserParams` interface.

Properties available on the `OverlayComponentUserParams` interface.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `loading` | `LoadingOverlayUserParams` |  |  |  |
| `noRows` | `NoRowsOverlayUserParams` |  |  |  |
| `noMatchingRows` | `NoMatchingRowsOverlayUserParams` |  |  |  |
| `exporting` | `ExportingOverlayUserParams` |  |  |  |
| `fileInput` | `FileInputOverlayUserParams` |  |  |  |

```ts
<ag-grid-angular
    [overlayComponentParams]="overlayComponentParams"
    /* other grid options ... */ />

this.overlayComponentParams = {
    loading: { overlayText: 'Please wait while your data is loading...' },
    noRows: { overlayText: 'This grid has no data!' },
    noMatchingRows: { overlayText: 'Current Filter Matches No Rows' },
    exporting: { overlayText: 'Exporting your data...' },
    fileInput: { overlayText: 'Provide a file...' },
};
```

#### Provided Overlays Custom Text

```ts
import { Component } from "@angular/core";
import { AgGridAngular } from "ag-grid-angular";
import "./styles.css";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  CsvExportModule,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  OverlayComponentUserParams,
  TextFilterModule,
  enableDevValidations,
} from "ag-grid-community";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ClientSideRowModelModule,
  CsvExportModule,
  TextFilterModule,
]);

interface IAthlete {
  athlete: string;
  country: string;
}

@Component({
  selector: "my-app",
  standalone: true,
  imports: [AgGridAngular],
  template: `<div class="example-wrapper">
    <div>
      <label class="checkbox">
        <input
          type="checkbox"
          checked=""
          (change)="setLoading($event.currentTarget.checked)"
        />
        loading
      </label>

      <button (click)="onBtnSetRowData()">Set Row Data</button>
      <button (click)="onBtnClearRowData()">Clear Row Data</button>
      <button (click)="onBtnSetFilter()">Set Non Matching Filter</button>
      <button (click)="onBtnClearFilter()">Clear Filter</button>
      <button (click)="onCsvExport()">Export CSV</button>
    </div>
    <ag-grid-angular
      style="width: 100%; height: 100%;"
      [overlayComponentParams]="overlayComponentParams"
      [loading]="true"
      [defaultColDef]="defaultColDef"
      [columnDefs]="columnDefs"
      [rowData]="rowData"
      (gridReady)="onGridReady($event)"
    />
  </div> `,
})
export class AppComponent {
  private gridApi!: GridApi<IAthlete>;

  overlayComponentParams: any = {
    loading: { overlayText: "Please wait while your data is loading..." },
    noRows: { overlayText: "This grid has no data!" },
    noMatchingRows: { overlayText: "Current Filter Matches No Rows" },
    exporting: { overlayText: "Exporting your data..." },
  };
  defaultColDef: ColDef = {
    filter: true,
  };
  columnDefs: ColDef[] = [{ field: "athlete" }, { field: "country" }];
  rowData!: IAthlete[];

  setLoading(value: boolean) {
    this.gridApi.setGridOption("loading", value);
  }

  onBtnClearRowData() {
    this.gridApi.setGridOption("rowData", []);
  }

  onBtnSetRowData() {
    this.gridApi.setGridOption("rowData", [
      { athlete: "Michael Phelps", country: "US" },
      { athlete: "Chris Hoy", country: "UK" },
    ]);
  }

  onBtnSetFilter() {
    this.gridApi.setGridOption("rowData", [
      { athlete: "Michael Phelps", country: "US" },
      { athlete: "Chris Hoy", country: "UK" },
    ]);
    this.gridApi.setFilterModel({
      country: { filterType: "text", type: "equals", filter: "Spain" },
    });
  }

  onBtnClearFilter() {
    this.gridApi.setFilterModel(null);
  }

  onCsvExport() {
    this.gridApi.exportDataAsCsv();
  }

  onGridReady(params: GridReadyEvent<IAthlete>) {
    this.gridApi = params.api;
  }
}
```

[Live example: Provided Overlays Custom Text](https://www.ag-grid.com/archive/36.2.0/examples/overlays-provided/provided-overlays-text/angular/)

### Custom Overlay Components

To provide a custom component for the provided overlays implement one of the following interfaces: `ILoadingOverlayAngularComp`, `INoRowsOverlayAngularComp`, `INoMatchingRowsOverlayAngularComp` or `IExportingOverlayAngularComp`.

Implement this interface to provide a custom overlay when data is being loaded.

```ts

interface ILoadingOverlayAngularComp {
  // Mandatory - Params for rendering this component. 
  agInit(params: ILoadingOverlayParams): void;

  // Gets called when the `overlayComponentParams` grid option is updated
  refresh?(params: TParams): void;

}
```

The `INoRowsOverlayAngularComp`, `INoMatchingRowsOverlayAngularComp` or `IExportingOverlayAngularComp` interfaces follow a similar pattern to the `ILoadingOverlayAngularComp` above.

Then set the custom overlay to its matching key in the `components` map as described in [Overriding Grid Components](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/components/#overriding-grid-components). Custom parameters can be supplied via the `overlayComponentParams` grid option.

```ts
<ag-grid-angular
    [components]="components"
    /* other grid options ... */ />

this.components = {
    agLoadingOverlay: CustomLoadingOverlay,
    agNoRowsOverlay: CustomNoRowsOverlay,
    agNoMatchingRowsOverlay: CustomNoMatchingRows,
    agExportingOverlay: CustomExportingOverlay
};
```

### Overlay Component Selector

To dynamically override a provided overlay with a custom component implement the `overlayComponentSelector(params)` callback. The callback params include an `overlayType` property which identifies which of the provided overlays that grid wants to display. The return type should match the `OverlaySelectorResult` interface.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `overlayComponentSelector` | `OverlaySelectorFunc` |  |  |  |

Returning `undefined` from the selector will fall back to the overlay specified in `params.overlayType`.

```ts
<ag-grid-angular
    [overlayComponentSelector]="overlayComponentSelector"
    /* other grid options ... */ />

this.overlayComponentSelector = (params) => {
    if (params.overlayType === 'loading') {
        return {
            component: CustomLoadingOverlay,
            params: {
                loadingMessage: 'Please wait while data is loading...'
            }
        };
    }
    // return undefined to use the provided overlay for other overlay types
    return undefined;
};
```

In the example below the loading overlay is overridden via the `overlayComponentSelector` but the no rows overlay is not.

#### Overlay Component Selector

```ts
import { Component } from "@angular/core";
import { AgGridAngular } from "ag-grid-angular";
import "./styles.css";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  GridReadyEvent,
  IOverlayParams,
  ModuleRegistry,
  OverlaySelectorFunc,
  enableDevValidations,
} from "ag-grid-community";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([ClientSideRowModelModule]);
import { CustomLoadingOverlay } from "./custom-loading-overlay.component";

interface IAthlete {
  athlete: string;
  country: string;
}

@Component({
  selector: "my-app",
  standalone: true,
  imports: [AgGridAngular, CustomLoadingOverlay],
  template: `<div class="example-wrapper">
    <div>
      <label class="checkbox">
        <input
          type="checkbox"
          checked=""
          (change)="setLoading($event.currentTarget.checked)"
        />
        loading
      </label>
    </div>
    <ag-grid-angular
      style="width: 100%; height: 100%;"
      [columnDefs]="columnDefs"
      [rowData]="rowData"
      [defaultColDef]="defaultColDef"
      [loading]="true"
      [overlayComponentSelector]="overlayComponentSelector"
      (gridReady)="onGridReady($event)"
    />
  </div> `,
})
export class AppComponent {
  private gridApi!: GridApi<IAthlete>;

  columnDefs: ColDef[] = [{ field: "athlete" }, { field: "country" }];
  rowData: IAthlete[] | null = [];
  defaultColDef: ColDef = {
    flex: 1,
  };
  overlayComponentSelector: OverlaySelectorFunc = (params: IOverlayParams) => {
    if (params.overlayType === "loading") {
      return {
        component: CustomLoadingOverlay,
        params: {
          loadingMessage: "Please wait while data is loading...",
        },
      };
    }
    // return undefined to use the provided overlay for other overlay types
    return undefined;
  };

  setLoading(value: boolean) {
    this.gridApi.setGridOption("loading", value);
  }

  onGridReady(params: GridReadyEvent<IAthlete>) {
    this.gridApi = params.api;
  }
}
```

[Live example: Overlay Component Selector](https://www.ag-grid.com/archive/36.2.0/examples/overlays-provided/custom-overlay-selector/angular/)

### Combined Overlay Component

Provide a custom component to `overlayComponent` to be used in place of all the provided overlays. The custom component receives a `overlayType` parameter which identifies which of the provided overlays should be displayed. This can be used to conditionally render different content based on the overlay type.

Custom parameters can be supplied to the overlay component via the `overlayComponentParams` grid option.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `overlayComponent` | `any` |  |  |  |
| `overlayComponentParams` | `any` |  |  |  |

```ts
<ag-grid-angular
    [overlayComponent]="overlayComponent"
    [overlayComponentParams]="overlayComponentParams"
    /* other grid options ... */ />

this.overlayComponent = CustomOverlay;
this.overlayComponentParams = {
    loadingMessage: 'Custom loading message',
    noRowsMessage: 'Custom no rows message'
};
```

In the example below a single custom component is provided to the grid which contains the conditional logic about what to render for each `overlayType`.

#### Overlay Component

```ts
import { Component } from "@angular/core";
import { AgGridAngular } from "ag-grid-angular";
import "./styles.css";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  enableDevValidations,
} from "ag-grid-community";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([ClientSideRowModelModule]);
import { CustomOverlay } from "./custom-overlay.component";

interface IAthlete {
  athlete: string;
  country: string;
}

@Component({
  selector: "my-app",
  standalone: true,
  imports: [AgGridAngular, CustomOverlay],
  template: `<div class="example-wrapper">
    <div>
      <label class="checkbox">
        <input
          type="checkbox"
          checked=""
          (change)="setLoading($event.currentTarget.checked)"
        />
        loading
      </label>
    </div>
    <ag-grid-angular
      style="width: 100%; height: 100%;"
      [columnDefs]="columnDefs"
      [defaultColDef]="defaultColDef"
      [loading]="true"
      [rowData]="rowData"
      [overlayComponent]="overlayComponent"
      [overlayComponentParams]="overlayComponentParams"
      (gridReady)="onGridReady($event)"
    />
  </div> `,
})
export class AppComponent {
  private gridApi!: GridApi<IAthlete>;

  columnDefs: ColDef[] = [{ field: "athlete" }, { field: "country" }];
  defaultColDef: ColDef = {
    flex: 1,
  };
  rowData: IAthlete[] | null = [];
  overlayComponent: any = CustomOverlay;
  overlayComponentParams: any = {
    loadingMessage: "Custom loading message",
    noRowsMessage: "Custom no rows message",
  };

  setLoading(value: boolean) {
    this.gridApi.setGridOption("loading", value);
  }

  onGridReady(params: GridReadyEvent<IAthlete>) {
    this.gridApi = params.api;
  }
}
```

[Live example: Overlay Component](https://www.ag-grid.com/archive/36.2.0/examples/overlays-provided/custom-overlay-component/angular/)

## Suppress Overlays

Each provided overlay can be suppressed via the `suppressOverlays` grid option which accepts an array of overlay types to suppress.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `suppressOverlays` | `OverlayType[]` |  |  |  |

## Legacy Customisation

Previously, the loading and no-rows overlays were customised via: `loadingOverlayComponent` and `noRowsOverlayComponent`. This approach is now superseded by the `overlayComponent` but the properties remain for backwards compatibility. The documentation for these properties is available [here](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/overlays/).


---
product: "AG Grid"
title: "Provided Overlays"
description: "The grid shows built-in overlays when data is loading or being exported and when there is no data or no rows match the current filter."
framework: vue
version: "36.2.0"
related:
    - title: "Overview"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/overlays-overview/"
    - title: "Active Overlay"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/overlays-active/"
    - title: "Loading Rows"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/loading-rows/"
llms: "https://www.ag-grid.com/archive/36.2.0/llms.txt"
---

# Provided Overlays

The grid shows built-in overlays when data is loading or being exported and when there is no data or no rows match the current filter.

The following example demonstrates most of the provided overlays.

- Toggle the loading state to show/hide the loading overlay.
- Note that the loading overlay takes precedence over the other provided overlays if they are shown at the same time.
- Clear Row Data shows the no rows overlay.
- Set Non Matching Filter sets row data and a non-matching filter to show the no matching rows overlay.
- Export CSV exports the data to CSV and shows the exporting overlay.

#### Provided Overlays

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import "./styles.css";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  CsvExportModule,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  TextFilterModule,
  enableDevValidations,
} from "ag-grid-community";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ClientSideRowModelModule,
  TextFilterModule,
  CsvExportModule,
]);

interface IAthlete {
  athlete: string;
  country: string;
}

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <div class="example-wrapper">
      <div>
        <label class="checkbox">
          <input type="checkbox" checked="" v-on:change="setLoading($event.currentTarget.checked)">
            loading
          </label>
          <button v-on:click="onBtnSetRowData()">Set Row Data</button>
          <button v-on:click="onBtnClearRowData()">Clear Row Data</button>
          <button v-on:click="onBtnSetFilter()">Set Non Matching Filter</button>
          <button v-on:click="onBtnClearFilter()">Clear Filter</button>
          <button v-on:click="onCsvExport()">Export CSV</button>
        </div>
        <ag-grid-vue
          style="width: 100%; height: 100%;"
          @grid-ready="onGridReady"
          :loading="true"
          :defaultColDef="defaultColDef"
          :columnDefs="columnDefs"
          :rowData="rowData"></ag-grid-vue>
        </div>
        </div>
    `,
  components: {
    "ag-grid-vue": AgGridVue,
  },
  setup(props) {
    const gridApi = shallowRef<GridApi<IAthlete> | null>(null);
    const defaultColDef = ref<ColDef>({
      filter: true,
    });
    const columnDefs = ref<ColDef[]>([
      { field: "athlete" },
      { field: "country" },
    ]);
    const rowData = ref<IAthlete[]>(null);

    function setLoading(value: boolean) {
      gridApi.value!.setGridOption("loading", value);
    }
    function onBtnClearRowData() {
      gridApi.value!.setGridOption("rowData", []);
    }
    function onBtnSetRowData() {
      gridApi.value!.setGridOption("rowData", [
        { athlete: "Michael Phelps", country: "US" },
        { athlete: "Chris Hoy", country: "UK" },
      ]);
    }
    function onBtnSetFilter() {
      gridApi.value!.setGridOption("rowData", [
        { athlete: "Michael Phelps", country: "US" },
        { athlete: "Chris Hoy", country: "UK" },
      ]);
      gridApi.value!.setFilterModel({
        country: { filterType: "text", type: "equals", filter: "Spain" },
      });
    }
    function onBtnClearFilter() {
      gridApi.value!.setFilterModel(null);
    }
    function onCsvExport() {
      gridApi.value!.exportDataAsCsv();
    }
    const onGridReady = (params: GridReadyEvent) => {
      gridApi.value = params.api;
    };

    return {
      gridApi,
      defaultColDef,
      columnDefs,
      rowData,
      onGridReady,
      setLoading,
      onBtnClearRowData,
      onBtnSetRowData,
      onBtnSetFilter,
      onBtnClearFilter,
      onCsvExport,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: Provided Overlays](https://www.ag-grid.com/archive/36.2.0/examples/overlays-provided/provided-overlays/vue3/)

## Loading

The loading overlay is displayed when the grid property `loading` is set to `true`, and takes precedence over the other provided overlays.

With the Client-Side Row Model, enable `loadingRows` to display [Loading Rows](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/loading-rows/) instead of the overlay while `loading=true`.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `loading` | `boolean` |  |  |  |

## No Rows

When there are no rows the grid automatically displays the no-rows overlay.

## No Matching Rows

The no-matching-rows overlay is displayed when the grid has rows but none of the rows match the current filter criteria.

## Exporting

The exporting overlay is displayed when data is being exported from the grid to CSV or Excel.

## File Input

When `processFileInput` is provided and `rowData` is not set, the grid shows a built-in file input overlay. Users can drag a file onto the overlay or click the browse button to select one. The `processFileInput` callback receives a `params` object containing the selected `files` along with `success` and `fail` callbacks, enabling the application to parse the files and load or reject the data.

The file input overlay pairs well with [Auto-Generate Columns](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/auto-generate-columns/#file-drop-overlay) to load data without defining columns upfront. See that page for the `processFileInput` callback and a worked example.

## Customisation

The provided overlays can be customised to change their content or completely replaced with custom components. The grid still manages the timing of when the overlays are displayed based on grid state.

### Text Customisation

Customise the text within the provided overlays via the `overlayComponentParams` grid option using the `OverlayComponentUserParams` interface.

Properties available on the `OverlayComponentUserParams` interface.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `loading` | `LoadingOverlayUserParams` |  |  |  |
| `noRows` | `NoRowsOverlayUserParams` |  |  |  |
| `noMatchingRows` | `NoMatchingRowsOverlayUserParams` |  |  |  |
| `exporting` | `ExportingOverlayUserParams` |  |  |  |
| `fileInput` | `FileInputOverlayUserParams` |  |  |  |

```ts
<ag-grid-vue
    :overlayComponentParams="overlayComponentParams"
    /* other grid options ... */>
</ag-grid-vue>

this.overlayComponentParams = {
    loading: { overlayText: 'Please wait while your data is loading...' },
    noRows: { overlayText: 'This grid has no data!' },
    noMatchingRows: { overlayText: 'Current Filter Matches No Rows' },
    exporting: { overlayText: 'Exporting your data...' },
    fileInput: { overlayText: 'Provide a file...' },
};
```

#### Provided Overlays Custom Text

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import "./styles.css";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  CsvExportModule,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  OverlayComponentUserParams,
  TextFilterModule,
  enableDevValidations,
} from "ag-grid-community";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ClientSideRowModelModule,
  CsvExportModule,
  TextFilterModule,
]);

interface IAthlete {
  athlete: string;
  country: string;
}

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <div class="example-wrapper">
      <div>
        <label class="checkbox">
          <input type="checkbox" checked="" v-on:change="setLoading($event.currentTarget.checked)">
            loading
          </label>
          <button v-on:click="onBtnSetRowData()">Set Row Data</button>
          <button v-on:click="onBtnClearRowData()">Clear Row Data</button>
          <button v-on:click="onBtnSetFilter()">Set Non Matching Filter</button>
          <button v-on:click="onBtnClearFilter()">Clear Filter</button>
          <button v-on:click="onCsvExport()">Export CSV</button>
        </div>
        <ag-grid-vue
          style="width: 100%; height: 100%;"
          @grid-ready="onGridReady"
          :overlayComponentParams="overlayComponentParams"
          :loading="true"
          :defaultColDef="defaultColDef"
          :columnDefs="columnDefs"
          :rowData="rowData"></ag-grid-vue>
        </div>
        </div>
    `,
  components: {
    "ag-grid-vue": AgGridVue,
  },
  setup(props) {
    const gridApi = shallowRef<GridApi<IAthlete> | null>(null);
    const overlayComponentParams = ref({
      loading: { overlayText: "Please wait while your data is loading..." },
      noRows: { overlayText: "This grid has no data!" },
      noMatchingRows: { overlayText: "Current Filter Matches No Rows" },
      exporting: { overlayText: "Exporting your data..." },
    });
    const defaultColDef = ref<ColDef>({
      filter: true,
    });
    const columnDefs = ref<ColDef[]>([
      { field: "athlete" },
      { field: "country" },
    ]);
    const rowData = ref<IAthlete[]>(null);

    function setLoading(value: boolean) {
      gridApi.value!.setGridOption("loading", value);
    }
    function onBtnClearRowData() {
      gridApi.value!.setGridOption("rowData", []);
    }
    function onBtnSetRowData() {
      gridApi.value!.setGridOption("rowData", [
        { athlete: "Michael Phelps", country: "US" },
        { athlete: "Chris Hoy", country: "UK" },
      ]);
    }
    function onBtnSetFilter() {
      gridApi.value!.setGridOption("rowData", [
        { athlete: "Michael Phelps", country: "US" },
        { athlete: "Chris Hoy", country: "UK" },
      ]);
      gridApi.value!.setFilterModel({
        country: { filterType: "text", type: "equals", filter: "Spain" },
      });
    }
    function onBtnClearFilter() {
      gridApi.value!.setFilterModel(null);
    }
    function onCsvExport() {
      gridApi.value!.exportDataAsCsv();
    }
    const onGridReady = (params: GridReadyEvent) => {
      gridApi.value = params.api;
    };

    return {
      gridApi,
      overlayComponentParams,
      defaultColDef,
      columnDefs,
      rowData,
      onGridReady,
      setLoading,
      onBtnClearRowData,
      onBtnSetRowData,
      onBtnSetFilter,
      onBtnClearFilter,
      onCsvExport,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: Provided Overlays Custom Text](https://www.ag-grid.com/archive/36.2.0/examples/overlays-provided/provided-overlays-text/vue3/)

### Custom Overlay Components

Any valid Vue component can be an overlay component, however it is also possible to implement the following optional methods:

```ts

interface ILoadingOverlay&lt;TData = any, TContext = any&gt; {
  // Gets called when the `overlayComponentParams` grid option is updated
  refresh?(params: TParams): void;

}
```

Then set the custom overlay to its matching key in the `components` map as described in [Overriding Grid Components](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/components/#overriding-grid-components). Custom parameters can be supplied via the `overlayComponentParams` grid option.

```ts
<ag-grid-vue
    :components="components"
    /* other grid options ... */>
</ag-grid-vue>

this.components = {
    agLoadingOverlay: CustomLoadingOverlay,
    agNoRowsOverlay: CustomNoRowsOverlay,
    agNoMatchingRowsOverlay: CustomNoMatchingRows,
    agExportingOverlay: CustomExportingOverlay
};
```

### Overlay Component Selector

To dynamically override a provided overlay with a custom component implement the `overlayComponentSelector(params)` callback. The callback params include an `overlayType` property which identifies which of the provided overlays that grid wants to display. The return type should match the `OverlaySelectorResult` interface.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `overlayComponentSelector` | `OverlaySelectorFunc` |  |  |  |

Returning `undefined` from the selector will fall back to the overlay specified in `params.overlayType`.

```ts
<ag-grid-vue
    :overlayComponentSelector="overlayComponentSelector"
    /* other grid options ... */>
</ag-grid-vue>

this.overlayComponentSelector = (params) => {
    if (params.overlayType === 'loading') {
        return {
            component: CustomLoadingOverlay,
            params: {
                loadingMessage: 'Please wait while data is loading...'
            }
        };
    }
    // return undefined to use the provided overlay for other overlay types
    return undefined;
};
```

In the example below the loading overlay is overridden via the `overlayComponentSelector` but the no rows overlay is not.

#### Overlay Component Selector

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import "./styles.css";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  GridReadyEvent,
  IOverlayParams,
  ModuleRegistry,
  OverlaySelectorFunc,
  enableDevValidations,
} from "ag-grid-community";
import CustomLoadingOverlay from "./customLoadingOverlayVue";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([ClientSideRowModelModule]);

interface IAthlete {
  athlete: string;
  country: string;
}

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <div class="example-wrapper">
      <div>
        <label class="checkbox">
          <input type="checkbox" checked="" v-on:change="setLoading($event.currentTarget.checked)">
            loading
          </label>
        </div>
        <ag-grid-vue
          style="width: 100%; height: 100%;"
          @grid-ready="onGridReady"
          :columnDefs="columnDefs"
          :rowData="rowData"
          :defaultColDef="defaultColDef"
          :loading="true"
          :overlayComponentSelector="overlayComponentSelector"></ag-grid-vue>
        </div>
        </div>
    `,
  components: {
    "ag-grid-vue": AgGridVue,
    CustomLoadingOverlay,
  },
  setup(props) {
    const gridApi = shallowRef<GridApi<IAthlete> | null>(null);
    const columnDefs = ref<ColDef[]>([
      { field: "athlete" },
      { field: "country" },
    ]);
    const rowData = ref<IAthlete[] | null>([]);
    const defaultColDef = ref<ColDef>({
      flex: 1,
    });
    const overlayComponentSelector = ref<OverlaySelectorFunc>(
      (params: IOverlayParams) => {
        if (params.overlayType === "loading") {
          return {
            component: "CustomLoadingOverlay",
            params: {
              loadingMessage: "Please wait while data is loading...",
            },
          };
        }
        // return undefined to use the provided overlay for other overlay types
        return undefined;
      },
    );

    function setLoading(value: boolean) {
      gridApi.value!.setGridOption("loading", value);
    }
    const onGridReady = (params: GridReadyEvent) => {
      gridApi.value = params.api;
    };

    return {
      gridApi,
      columnDefs,
      rowData,
      defaultColDef,
      overlayComponentSelector,
      onGridReady,
      setLoading,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: Overlay Component Selector](https://www.ag-grid.com/archive/36.2.0/examples/overlays-provided/custom-overlay-selector/vue3/)

### Combined Overlay Component

Provide a custom component to `overlayComponent` to be used in place of all the provided overlays. The custom component receives a `overlayType` parameter which identifies which of the provided overlays should be displayed. This can be used to conditionally render different content based on the overlay type.

Custom parameters can be supplied to the overlay component via the `overlayComponentParams` grid option.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `overlayComponent` | `any` |  |  |  |
| `overlayComponentParams` | `any` |  |  |  |

```ts
<ag-grid-vue
    :overlayComponent="overlayComponent"
    :overlayComponentParams="overlayComponentParams"
    /* other grid options ... */>
</ag-grid-vue>

this.overlayComponent = CustomOverlay;
this.overlayComponentParams = {
    loadingMessage: 'Custom loading message',
    noRowsMessage: 'Custom no rows message'
};
```

In the example below a single custom component is provided to the grid which contains the conditional logic about what to render for each `overlayType`.

#### Overlay Component

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import "./styles.css";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  enableDevValidations,
} from "ag-grid-community";
import CustomOverlay from "./customOverlayVue";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([ClientSideRowModelModule]);

interface IAthlete {
  athlete: string;
  country: string;
}

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <div class="example-wrapper">
      <div>
        <label class="checkbox">
          <input type="checkbox" checked="" v-on:change="setLoading($event.currentTarget.checked)">
            loading
          </label>
        </div>
        <ag-grid-vue
          style="width: 100%; height: 100%;"
          @grid-ready="onGridReady"
          :columnDefs="columnDefs"
          :defaultColDef="defaultColDef"
          :loading="true"
          :rowData="rowData"
          :overlayComponent="overlayComponent"
          :overlayComponentParams="overlayComponentParams"></ag-grid-vue>
        </div>
        </div>
    `,
  components: {
    "ag-grid-vue": AgGridVue,
    CustomOverlay,
  },
  setup(props) {
    const gridApi = shallowRef<GridApi<IAthlete> | null>(null);
    const columnDefs = ref<ColDef[]>([
      { field: "athlete" },
      { field: "country" },
    ]);
    const defaultColDef = ref<ColDef>({
      flex: 1,
    });
    const rowData = ref<IAthlete[] | null>([]);
    const overlayComponent = ref("CustomOverlay");
    const overlayComponentParams = ref({
      loadingMessage: "Custom loading message",
      noRowsMessage: "Custom no rows message",
    });

    function setLoading(value: boolean) {
      gridApi.value!.setGridOption("loading", value);
    }
    const onGridReady = (params: GridReadyEvent) => {
      gridApi.value = params.api;
    };

    return {
      gridApi,
      columnDefs,
      defaultColDef,
      rowData,
      overlayComponent,
      overlayComponentParams,
      onGridReady,
      setLoading,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: Overlay Component](https://www.ag-grid.com/archive/36.2.0/examples/overlays-provided/custom-overlay-component/vue3/)

## Suppress Overlays

Each provided overlay can be suppressed via the `suppressOverlays` grid option which accepts an array of overlay types to suppress.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `suppressOverlays` | `OverlayType[]` |  |  |  |

## Legacy Customisation

Previously, the loading and no-rows overlays were customised via: `loadingOverlayComponent` and `noRowsOverlayComponent`. This approach is now superseded by the `overlayComponent` but the properties remain for backwards compatibility. The documentation for these properties is available [here](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/overlays/).


---
product: "AG Grid"
title: "Provided Overlays"
description: "The grid shows built-in overlays when data is loading or being exported and when there is no data or no rows match the current filter."
framework: react
version: "36.2.0"
related:
    - title: "Overview"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/overlays-overview/"
    - title: "Active Overlay"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/overlays-active/"
    - title: "Loading Rows"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/loading-rows/"
llms: "https://www.ag-grid.com/archive/36.2.0/llms.txt"
---

# Provided Overlays

The grid shows built-in overlays when data is loading or being exported and when there is no data or no rows match the current filter.

The following example demonstrates most of the provided overlays.

- Toggle the loading state to show/hide the loading overlay.
- Note that the loading overlay takes precedence over the other provided overlays if they are shown at the same time.
- Clear Row Data shows the no rows overlay.
- Set Non Matching Filter sets row data and a non-matching filter to show the no matching rows overlay.
- Export CSV exports the data to CSV and shows the exporting overlay.

#### Provided Overlays

```tsx
'use client';
import React, { StrictMode, useRef, useState } from "react";
import { createRoot } from "react-dom/client";

import {
  ClientSideRowModelModule,
  CsvExportModule,
  TextFilterModule,
  enableDevValidations,
} from "ag-grid-community";
import type { ColDef } from "ag-grid-community";
import { AgGridProvider, AgGridReact } from "ag-grid-react";

import "./styles.css";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

const modules = [ClientSideRowModelModule, TextFilterModule, CsvExportModule];

interface IAthlete {
  athlete: string;
  country: string;
}

const columnDefs: ColDef[] = [{ field: "athlete" }, { field: "country" }];

const defaultColDef: ColDef = {
  filter: true,
};

const rawRowData = [
  { athlete: "Michael Phelps", country: "US" },
  { athlete: "Chris Hoy", country: "UK" },
];

const GridExample = () => {
  const [loading, setLoading] = useState(true);
  const [rowData, setRowData] = useState<IAthlete[] | undefined>();
  const gridRef = useRef<AgGridReact>(null);

  return (
    <AgGridProvider modules={modules}>
      <div className="example-wrapper">
        <div>
          <label className="checkbox">
            <input
              type="checkbox"
              onChange={(e) => setLoading(e.target.checked)}
              defaultChecked={loading}
            />
            loading
          </label>

          <button onClick={() => setRowData(rawRowData)}>Set Row Data</button>
          <button onClick={() => setRowData([])}>Clear Row Data</button>
          <button
            onClick={() => {
              setRowData(rawRowData);
              gridRef.current?.api.setFilterModel({
                country: {
                  filterType: "text",
                  type: "equals",
                  filter: "Spain",
                },
              });
            }}
          >
            Set Non Matching Filter
          </button>
          <button onClick={() => gridRef.current?.api.setFilterModel(null)}>
            Clear Filter
          </button>
          <button onClick={() => gridRef.current?.api.exportDataAsCsv()}>
            Export CSV
          </button>
        </div>

        <div style={{ height: "100%" }}>
          <AgGridReact
            ref={gridRef}
            loading={loading}
            rowData={rowData}
            columnDefs={columnDefs}
            defaultColDef={defaultColDef}
          />
        </div>
      </div>
    </AgGridProvider>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: Provided Overlays](https://www.ag-grid.com/archive/36.2.0/examples/overlays-provided/provided-overlays/reactFunctionalTs/)

## Loading

The loading overlay is displayed when the grid property `loading` is set to `true`, and takes precedence over the other provided overlays.

With the Client-Side Row Model, enable `loadingRows` to display [Loading Rows](https://www.ag-grid.com/archive/36.2.0/react-data-grid/loading-rows/) instead of the overlay while `loading=true`.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `loading` | `boolean` |  |  |  |

## No Rows

When there are no rows the grid automatically displays the no-rows overlay.

## No Matching Rows

The no-matching-rows overlay is displayed when the grid has rows but none of the rows match the current filter criteria.

## Exporting

The exporting overlay is displayed when data is being exported from the grid to CSV or Excel.

## File Input

When `processFileInput` is provided and `rowData` is not set, the grid shows a built-in file input overlay. Users can drag a file onto the overlay or click the browse button to select one. The `processFileInput` callback receives a `params` object containing the selected `files` along with `success` and `fail` callbacks, enabling the application to parse the files and load or reject the data.

The file input overlay pairs well with [Auto-Generate Columns](https://www.ag-grid.com/archive/36.2.0/react-data-grid/auto-generate-columns/#file-drop-overlay) to load data without defining columns upfront. See that page for the `processFileInput` callback and a worked example.

## Customisation

The provided overlays can be customised to change their content or completely replaced with custom components. The grid still manages the timing of when the overlays are displayed based on grid state.

### Text Customisation

Customise the text within the provided overlays via the `overlayComponentParams` grid option using the `OverlayComponentUserParams` interface.

Properties available on the `OverlayComponentUserParams` interface.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `loading` | `LoadingOverlayUserParams` |  |  |  |
| `noRows` | `NoRowsOverlayUserParams` |  |  |  |
| `noMatchingRows` | `NoMatchingRowsOverlayUserParams` |  |  |  |
| `exporting` | `ExportingOverlayUserParams` |  |  |  |
| `fileInput` | `FileInputOverlayUserParams` |  |  |  |

```jsx
const overlayComponentParams = {
    loading: { overlayText: 'Please wait while your data is loading...' },
    noRows: { overlayText: 'This grid has no data!' },
    noMatchingRows: { overlayText: 'Current Filter Matches No Rows' },
    exporting: { overlayText: 'Exporting your data...' },
    fileInput: { overlayText: 'Provide a file...' },
};

<AgGridReact overlayComponentParams={overlayComponentParams} />
```

#### Provided Overlays Custom Text

```tsx
'use client';
import React, { StrictMode, useRef, useState } from "react";
import { createRoot } from "react-dom/client";

import {
  ClientSideRowModelModule,
  CsvExportModule,
  TextFilterModule,
  enableDevValidations,
} from "ag-grid-community";
import type { ColDef, OverlayComponentUserParams } from "ag-grid-community";
import { AgGridProvider, AgGridReact } from "ag-grid-react";

import "./styles.css";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

const modules = [ClientSideRowModelModule, CsvExportModule, TextFilterModule];

interface IAthlete {
  athlete: string;
  country: string;
}

const columnDefs: ColDef[] = [{ field: "athlete" }, { field: "country" }];

const defaultColDef: ColDef = {
  filter: true,
};

const rawRowData = [
  { athlete: "Michael Phelps", country: "US" },
  { athlete: "Chris Hoy", country: "UK" },
];

const overlayComponentParams: OverlayComponentUserParams = {
  loading: { overlayText: "Please wait while your data is loading..." },
  noRows: { overlayText: "This grid has no data!" },
  noMatchingRows: { overlayText: "Current Filter Matches No Rows" },
  exporting: { overlayText: "Exporting your data..." },
};
const GridExample = () => {
  const [loading, setLoading] = useState(true);
  const [rowData, setRowData] = useState<IAthlete[] | undefined>();
  const gridRef = useRef<AgGridReact>(null);

  return (
    <AgGridProvider modules={modules}>
      <div className="example-wrapper">
        <div>
          <label className="checkbox">
            <input
              type="checkbox"
              onChange={(e) => setLoading(e.target.checked)}
              defaultChecked={loading}
            />
            loading
          </label>

          <button onClick={() => setRowData(rawRowData)}>Set Row Data</button>
          <button onClick={() => setRowData([])}>Clear Row Data</button>
          <button
            onClick={() => {
              setRowData(rawRowData);
              gridRef.current?.api.setFilterModel({
                country: {
                  filterType: "text",
                  type: "equals",
                  filter: "Spain",
                },
              });
            }}
          >
            Set Non Matching Filter
          </button>
          <button onClick={() => gridRef.current?.api.setFilterModel(null)}>
            Clear Filter
          </button>
          <button onClick={() => gridRef.current?.api.exportDataAsCsv()}>
            Export CSV
          </button>
        </div>

        <div style={{ height: "100%" }}>
          <AgGridReact
            ref={gridRef}
            loading={loading}
            rowData={rowData}
            columnDefs={columnDefs}
            defaultColDef={defaultColDef}
            overlayComponentParams={overlayComponentParams}
          />
        </div>
      </div>
    </AgGridProvider>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: Provided Overlays Custom Text](https://www.ag-grid.com/archive/36.2.0/examples/overlays-provided/provided-overlays-text/reactFunctionalTs/)

### Custom Overlay Components

Then set the custom overlay to its matching key in the `components` map as described in [Overriding Grid Components](https://www.ag-grid.com/archive/36.2.0/react-data-grid/components/#overriding-grid-components). Custom parameters can be supplied via the `overlayComponentParams` grid option.

```jsx
const components = {
    agLoadingOverlay: CustomLoadingOverlay,
    agNoRowsOverlay: CustomNoRowsOverlay,
    agNoMatchingRowsOverlay: CustomNoMatchingRows,
    agExportingOverlay: CustomExportingOverlay
};

<AgGridReact components={components} />
```

### Overlay Component Selector

To dynamically override a provided overlay with a custom component implement the `overlayComponentSelector(params)` callback. The callback params include an `overlayType` property which identifies which of the provided overlays that grid wants to display. The return type should match the `OverlaySelectorResult` interface.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `overlayComponentSelector` | `OverlaySelectorFunc` |  |  |  |

Returning `undefined` from the selector will fall back to the overlay specified in `params.overlayType`.

```jsx
const overlayComponentSelector = (params) => {
    if (params.overlayType === 'loading') {
        return {
            component: CustomLoadingOverlay,
            params: {
                loadingMessage: 'Please wait while data is loading...'
            }
        };
    }
    // return undefined to use the provided overlay for other overlay types
    return undefined;
};

<AgGridReact overlayComponentSelector={overlayComponentSelector} />
```

In the example below the loading overlay is overridden via the `overlayComponentSelector` but the no rows overlay is not.

#### Overlay Component Selector

```tsx
'use client';
import React, { StrictMode, useCallback, useState } from "react";
import { createRoot } from "react-dom/client";

import {
  ClientSideRowModelModule,
  enableDevValidations,
} from "ag-grid-community";
import type { ColDef, IOverlayParams } from "ag-grid-community";
import { AgGridProvider, AgGridReact } from "ag-grid-react";

import CustomLoadingOverlay from "./customLoadingOverlay";
import "./styles.css";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

const modules = [ClientSideRowModelModule];

interface IAthlete {
  athlete: string;
  country: string;
}

const columnDefs: ColDef[] = [{ field: "athlete" }, { field: "country" }];

const rowData: IAthlete[] = [];

const defaultColDef: ColDef = {
  flex: 1,
};

const GridExample = () => {
  const [loading, setLoading] = useState(true);

  const overlayComponentSelector = useCallback((params: IOverlayParams) => {
    if (params.overlayType === "loading") {
      return {
        component: CustomLoadingOverlay,
        params: {
          loadingMessage: "Please wait while data is loading...",
        },
      };
    }
    // return undefined to use the provided overlay for other overlay types
    return undefined;
  }, []);

  return (
    <AgGridProvider modules={modules}>
      <div className="example-wrapper">
        <div>
          <label className="checkbox">
            <input
              type="checkbox"
              onChange={(e) => setLoading(e.target.checked)}
              checked={loading}
            />
            loading
          </label>
        </div>

        <div style={{ height: "100%", width: "100%" }}>
          <AgGridReact<IAthlete>
            loading={loading}
            rowData={rowData}
            columnDefs={columnDefs}
            defaultColDef={defaultColDef}
            overlayComponentSelector={overlayComponentSelector}
          />
        </div>
      </div>
    </AgGridProvider>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: Overlay Component Selector](https://www.ag-grid.com/archive/36.2.0/examples/overlays-provided/custom-overlay-selector/reactFunctionalTs/)

### Combined Overlay Component

Provide a custom component to `overlayComponent` to be used in place of all the provided overlays. The custom component receives a `overlayType` parameter which identifies which of the provided overlays should be displayed. This can be used to conditionally render different content based on the overlay type.

Custom parameters can be supplied to the overlay component via the `overlayComponentParams` grid option.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `overlayComponent` | `any` |  |  |  |
| `overlayComponentParams` | `any` |  |  |  |

```jsx
const overlayComponent = CustomOverlay;
const overlayComponentParams = {
    loadingMessage: 'Custom loading message',
    noRowsMessage: 'Custom no rows message'
};

<AgGridReact
    overlayComponent={overlayComponent}
    overlayComponentParams={overlayComponentParams}
/>
```

In the example below a single custom component is provided to the grid which contains the conditional logic about what to render for each `overlayType`.

#### Overlay Component

```tsx
'use client';
import React, { StrictMode, useMemo, useState } from "react";
import { createRoot } from "react-dom/client";

import {
  ClientSideRowModelModule,
  enableDevValidations,
} from "ag-grid-community";
import type { ColDef } from "ag-grid-community";
import { AgGridProvider, AgGridReact } from "ag-grid-react";

import CustomOverlay from "./customOverlay";
import "./styles.css";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

const modules = [ClientSideRowModelModule];

interface IAthlete {
  athlete: string;
  country: string;
}

const columnDefs: ColDef[] = [{ field: "athlete" }, { field: "country" }];

const rowData: IAthlete[] = [];

const defaultColDef: ColDef = {
  flex: 1,
};

const GridExample = () => {
  const [loading, setLoading] = useState(true);

  const overlayComponentParams = useMemo(() => {
    return {
      loadingMessage: "Custom loading message",
      noRowsMessage: "Custom no rows message",
    };
  }, []);

  return (
    <AgGridProvider modules={modules}>
      <div className="example-wrapper">
        <div>
          <label className="checkbox">
            <input
              type="checkbox"
              onChange={(e) => setLoading(e.target.checked)}
              checked={loading}
            />
            loading
          </label>
        </div>

        <div style={{ height: "100%", width: "100%" }}>
          <AgGridReact<IAthlete>
            loading={loading}
            rowData={rowData}
            columnDefs={columnDefs}
            defaultColDef={defaultColDef}
            overlayComponent={CustomOverlay}
            overlayComponentParams={overlayComponentParams}
          />
        </div>
      </div>
    </AgGridProvider>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: Overlay Component](https://www.ag-grid.com/archive/36.2.0/examples/overlays-provided/custom-overlay-component/reactFunctionalTs/)

## Suppress Overlays

Each provided overlay can be suppressed via the `suppressOverlays` grid option which accepts an array of overlay types to suppress.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `suppressOverlays` | `OverlayType[]` |  |  |  |

## Legacy Customisation

Previously, the loading and no-rows overlays were customised via: `loadingOverlayComponent` and `noRowsOverlayComponent`. This approach is now superseded by the `overlayComponent` but the properties remain for backwards compatibility. The documentation for these properties is available [here](https://www.ag-grid.com/archive/36.2.0/react-data-grid/overlays/).
